"use strict";

var _types = require("./types");

var _utils = require("./utils");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

describe('getNextMoveIndex', function () {
  it.each(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    currentSlide | slideCount | slidesToScroll | expected\n    ", "         | ", "       | ", "           | ", "\n    ", "         | ", "       | ", "           | ", "\n    ", "        | ", "       | ", "           | ", "\n    ", "         | ", "       | ", "           | ", "\n    ", "         | ", "       | ", "           | ", "\n  "])), 1, 3, 2, 3, 1, 2, 2, 3, -1, 2, 1, 0, 1, 1, 1, 2, 1, 2, 1, 2)('does basic calculation with wrapAround=true ' + '(currentSlide $currentSlide, slideCount $slideCount, slidesToScroll $slidesToScroll)', function (_ref) {
    var currentSlide = _ref.currentSlide,
        slideCount = _ref.slideCount,
        slidesToScroll = _ref.slidesToScroll,
        expected = _ref.expected;
    var args = [_types.ScrollMode.page, true, currentSlide, slideCount, slidesToScroll, 1];
    expect(_utils.getNextMoveIndex.apply(void 0, args.concat(['left']))).toEqual(expected);
    expect(_utils.getNextMoveIndex.apply(void 0, args.concat(['right']))).toEqual(expected);
    expect(_utils.getNextMoveIndex.apply(void 0, args.concat(['center']))).toEqual(expected);
  });
  it.each(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    currentSlide | slidesToShow | slidesToScroll | cellAlign   | expected\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "       | ", "         | ", "           | ", "   | ", "\n    ", "       | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "         | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "       | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "         | ", "   | ", "\n    ", "         | ", "       | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "       | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "         | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "       | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "         | ", "  | ", "\n    ", "         | ", "       | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "       | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "         | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "       | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "         | ", " | ", "\n    ", "         | ", "       | ", "           | ", " | ", "\n  "])), 2, 1, 1, 'left', 2, 1, 1, 1, 'left', 2, 1.5, 1, 1, 'left', 2, 1.5, 2, 1, 'left', 1.5, 2, 2, 1, 'left', 2, 1, 2, 1, 'left', 1, 1, 2, 2, 'left', 1, 1, 2, 1.5, 'left', 1, 0, 1, 1, 'left', 1, 0.5, 1, 1, 'left', 1.5, 0, 2, 1, 'left', 1, 0, 2, 2, 'left', 2, 0, 2, 1.5, 'left', 1.5, 0, 1.5, 2, 'left', 2, 2, 1, 1, 'right', 2, 1, 1, 1, 'right', 2, 1.5, 1, 1, 'right', 2, 1, 2, 1, 'right', 2, 1, 2, 2, 'right', 2, 1, 2, 1.5, 'right', 2, 0, 1, 1, 'right', 1, 0.5, 1, 1, 'right', 1.5, 0, 2, 1, 'right', 1, 0, 2, 2, 'right', 2, 0, 2, 1.5, 'right', 1.5, 0, 1.5, 2, 'right', 2, 2, 1, 1, 'center', 2, 1, 1, 1, 'center', 2, 1.5, 1, 1, 'center', 2, 1, 2, 1, 'center', 2, 1, 2, 2, 'center', 2, 1, 2, 1.5, 'center', 2, 0, 1, 1, 'center', 1, 0.5, 1, 1, 'center', 1.5, 0, 2, 1, 'center', 1, 0, 2, 2, 'center', 2, 0, 2, 1.5, 'center', 1.5, 0, 1.5, 2, 'center', 2)('gets correct index when allowing whitespace ' + '(slideIndex $currentSlide, $slidesToShow slidesToShow, $slidesToScroll slidesToScroll, $cellAlign align)', function (_ref2) {
    var currentSlide = _ref2.currentSlide,
        slidesToShow = _ref2.slidesToShow,
        slidesToScroll = _ref2.slidesToScroll,
        cellAlign = _ref2.cellAlign,
        expected = _ref2.expected;
    expect((0, _utils.getNextMoveIndex)(_types.ScrollMode.page, false, currentSlide, 3, slidesToScroll, slidesToShow, cellAlign)).toEqual(expected);
  });
  it.each(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    currentSlide | slidesToShow | slidesToScroll | cellAlign   | expected\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "       | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "         | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "       | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "         | ", "   | ", "\n    ", "         | ", "         | ", "          | ", "   | ", "\n    ", "         | ", "       | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n  "])), 2, 1, 1, 'left', 2, 1, 1, 1, 'left', 2, 1.5, 1, 1, 'left', 2, 1, 2, 1, 'left', 1, 1, 2, 2, 'left', 1, 1, 2, 1.5, 'left', 1, 0, 1, 1, 'left', 1, 0.5, 1, 1, 'left', 1.5, 0, 2, 1, 'left', 1, 0, 2, 2, 'left', 1, 0, 2, 1.5, 'left', 1, 3, 1, 11, 'left', 3, 0, 1.5, 2, 'left', 1.5, 1, 2, 1, 'center', 2, 1, 2, 1, 'right', 2)('gets correct index when avoiding whitespace ' + '(slideIndex $currentSlide, $slidesToShow slidesToShow, $slidesToScroll slidesToScroll, $cellAlign align)', function (_ref3) {
    var currentSlide = _ref3.currentSlide,
        slidesToShow = _ref3.slidesToShow,
        slidesToScroll = _ref3.slidesToScroll,
        cellAlign = _ref3.cellAlign,
        expected = _ref3.expected;
    expect((0, _utils.getNextMoveIndex)(_types.ScrollMode.remainder, false, currentSlide, 3, slidesToScroll, slidesToShow, cellAlign)).toEqual(expected);
  });
});
describe('getPrevMoveIndex', function () {
  it.each(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n    currentSlide | slidesToScroll | expected\n    ", "         | ", "           | ", "\n    ", "         | ", "           | ", "\n    ", "        | ", "           | ", "\n  "])), 1, 2, -1, 4, 2, 2, -1, 1, -2)('does basic calculation with wrapAround=true ' + '(currentSlide $currentSlide, slidesToScroll $slidesToScroll)', function (_ref4) {
    var currentSlide = _ref4.currentSlide,
        slidesToScroll = _ref4.slidesToScroll,
        expected = _ref4.expected;
    expect((0, _utils.getPrevMoveIndex)(_types.ScrollMode.page, true, currentSlide, slidesToScroll, 1, 'left')).toEqual(expected);
  });
  it.each(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n    currentSlide | slidesToShow | slidesToScroll | cellAlign   | expected\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "       | ", "         | ", "           | ", "   | ", "\n    ", "       | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "         | ", "   | ", "\n    ", "         | ", "         | ", "         | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n    ", "         | ", "       | ", "           | ", "   | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "       | ", "         | ", "           | ", "  | ", "\n    ", "       | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "         | ", "  | ", "\n    ", "         | ", "         | ", "         | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "       | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "       | ", "         | ", "           | ", " | ", "\n    ", "       | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "         | ", " | ", "\n    ", "         | ", "         | ", "         | ", " | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "       | ", "           | ", " | ", "\n  "])), 0, 1, 1, 'left', 0, 1, 1, 1, 'left', 0, 1.5, 1, 1, 'left', 0.5, 1.5, 2, 1, 'left', 0.5, 1, 2, 1, 'left', 0, 1, 2, 2, 'left', 0, 1, 2, 1.5, 'left', 0, 2, 2, 1.5, 'left', 0.5, 2, 2, 2, 'left', 0, 2, 1.5, 2, 'left', 0, 0, 1, 1, 'right', 0, 1, 1, 1, 'right', 0, 1.5, 1, 1, 'right', 0.5, 1.5, 2, 1, 'right', 0.5, 1, 2, 1, 'right', 1, 1, 2, 2, 'right', 1, 1, 2, 1.5, 'right', 1, 2, 2, 1.5, 'right', 0.5, 2, 2, 2, 'right', 0, 2, 1.5, 2, 'right', 0, 0, 1, 1, 'center', 0, 1, 1, 1, 'center', 0, 1.5, 1, 1, 'center', 0.5, 1.5, 2, 1, 'center', 0.5, 1, 2, 1, 'center', 0, 1, 2, 2, 'center', 0, 1, 2, 1.5, 'center', 0, 2, 2, 1.5, 'center', 0.5, 2, 2, 2, 'center', 0, 2, 1.5, 2, 'center', 0)('gets correct index when allowing whitespace ' + '(slideIndex $currentSlide, $slidesToShow slidesToShow, $slidesToScroll slidesToScroll, $cellAlign align)', function (_ref5) {
    var currentSlide = _ref5.currentSlide,
        slidesToShow = _ref5.slidesToShow,
        slidesToScroll = _ref5.slidesToScroll,
        cellAlign = _ref5.cellAlign,
        expected = _ref5.expected;
    expect((0, _utils.getPrevMoveIndex)(_types.ScrollMode.page, false, currentSlide, slidesToScroll, slidesToShow, cellAlign)).toEqual(expected);
  });
  it.each(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n    currentSlide | slidesToShow | slidesToScroll | cellAlign   | expected\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "       | ", "         | ", "           | ", "  | ", "\n    ", "       | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "         | ", "  | ", "\n    ", "         | ", "         | ", "         | ", "  | ", "\n    ", "         | ", "         | ", "           | ", "  | ", "\n    ", "         | ", "       | ", "           | ", "  | ", "\n    ", "         | ", "         | ", "           | ", " | ", "\n    ", "         | ", "         | ", "           | ", "   | ", "\n  "])), 0, 1, 1, 'right', 0, 1, 1, 1, 'right', 0, 1.5, 1, 1, 'right', 0.5, 1.5, 2, 1, 'right', 1, 1, 2, 1, 'right', 1, 1, 2, 2, 'right', 1, 1, 2, 1.5, 'right', 1, 2, 2, 1.5, 'right', 1, 2, 2, 2, 'right', 1, 2, 1.5, 2, 'right', 0.5, 1, 2, 1, 'center', 0, 1, 2, 1, 'left', 0)('gets correct index when avoiding whitespace ' + '(slideIndex $currentSlide, $slidesToShow slidesToShow, $slidesToScroll slidesToScroll, $cellAlign align)', function (_ref6) {
    var currentSlide = _ref6.currentSlide,
        slidesToShow = _ref6.slidesToShow,
        slidesToScroll = _ref6.slidesToScroll,
        cellAlign = _ref6.cellAlign,
        expected = _ref6.expected;
    expect((0, _utils.getPrevMoveIndex)(_types.ScrollMode.remainder, false, currentSlide, slidesToScroll, slidesToShow, cellAlign)).toEqual(expected);
  });
});
describe('getBoundedIndex', function () {
  it.each(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n    rawIndex | slideCount | expected\n    ", "     | ", "       | ", "\n    ", "     | ", "       | ", "\n    ", "     | ", "       | ", "\n    ", "     | ", "       | ", "\n    ", "     | ", "       | ", "\n    ", "    | ", "       | ", "\n    ", "    | ", "       | ", "\n    ", "    | ", "       | ", "\n    ", "    | ", "       | ", "\n    ", "    | ", "       | ", "\n    ", "    | ", "       | ", "\n    ", "  | ", "       | ", "\n  "])), 0, 1, 0, 1, 2, 1, 2, 2, 0, 3, 2, 1, 4, 2, 0, -1, 2, 1, -2, 2, 0, -2, 3, 1, -3, 3, 0, -6, 3, 0, -7, 3, 2, -7.5, 3, 1.5)('gets the right index when bounds applied ' + '(rawIndex $rawIndex, slideCount $slideCount)', function (_ref7) {
    var rawIndex = _ref7.rawIndex,
        slideCount = _ref7.slideCount,
        expected = _ref7.expected;
    expect((0, _utils.getBoundedIndex)(rawIndex, slideCount)).toEqual(expected);
  });
});